unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, voicerlibLib_TLB, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    btnInicializaVlib: TButton;
    btnFinalizaVlib: TButton;
    btnAtender1: TButton;
    txtPorta1: TEdit;
    btnAtender2: TButton;
    txtPorta2: TEdit;
    memStatus: TMemo;
    btnComutar: TButton;
    vlib: Tvoicerlib;
    btnDesligar: TButton;
    Timer1: TTimer;
    Button1: TButton;
    btnGravar: TButton;
    btnPararGravacao: TButton;
    Image1: TImage;
    Label1: TLabel;
    txtRecordGain: TEdit;
    updRecordGain: TUpDown;
    procedure btnInicializaVlibClick(Sender: TObject);
    procedure btnFinalizaVlibClick(Sender: TObject);
    procedure btnAtender1Click(Sender: TObject);
    procedure btnAtender2Click(Sender: TObject);
    procedure btnComutarClick(Sender: TObject);
    procedure vlibRingDetected(ASender: TObject; Port: Smallint);
    procedure btnDesligarClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnGravarClick(Sender: TObject);
    procedure btnPararGravacaoClick(Sender: TObject);
    procedure vlibRecording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MostraStatus(nPorta : Integer; sMsg: String);
  end;

var
  Form1: TForm1;
  sReturn    : array [0..255] of Char;
  nRet1,nRet2 : integer;

implementation

{$R *.dfm}

procedure TForm1.MostraStatus(nPorta : Integer; sMsg: String);
begin
  try
    memStatus.Lines.Add('<' + TimeToStr(Time) + '>' + IntToStr(nPorta) + ' -> ' + sMsg);
  except;
    Application.MessageBox('MostraStatus', 'Except', mb_OK);
  end;
end;

procedure TForm1.btnInicializaVlibClick(Sender: TObject);
var
  nRet : Integer;
  i : integer;

begin
  //Inicializa a Voicerlib
  nRet := vlib.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(0,'StartVoicerLib - ' + sReturn);

  if nRet = DG_EXIT_SUCCESS then
  begin                  
    //Para todas as portas
    for i:=1 to vlib.GetPortInterface(i) do
    begin
      //Verifica o tipo da placa daquela porta
      if (vlib.GetPortInterface(i) = DG_DIGITAL_INTERFACE) then
      begin
        //Se for E1 cria thread
        if vlib.CreateE1Thread(i) <> DG_EXIT_SUCCESS then
        begin
          MostraStatus(i,'Erro ao criar thread E1');
          //Finaliza a Voicerlib
          nRet := vlib.ShutdownVoicerLib; 
          if nRet <> DG_EXIT_SUCCESS then
            MostraStatus(i,'Erro ao finalizar a VoicerLib'); 
          exit; 
        end
        else
        begin
          MostraStatus(i,'Porta E1 ' + IntToStr(i) + ' OK');
          vlib.ConfigE1Thread(i,E1CFG_MAXDIGITS_RX,4);
          //Em ligacoes de entrada, pede bina apos o 2 digito
          vlib.ConfigE1Thread(i,E1CFG_SEND_ID_AFTERDIGIT,2);
          vlib.ConfigE1Thread(i,E1CFG_GROUP_B,1);
          //Categoria a ser enviada em ligacoes saintes
          vlib.ConfigE1Thread(i,E1CFG_GROUP_II,1);
          vlib.SetPortId(i,'1121916363');
        end;
      end;
    end; 

    for i:=1 to vlib.GetCardsCount do
    begin
      if (vlib.GetCardInterface(i) = DG_DIGITAL_INTERFACE) then
      begin
        MostraStatus(i,'Sincronismo da placa ' + IntToStr(i) + ' em SYNC_LINE_A');
        vlib.SetCardSyncMode(i,SYNC_LINE_A);//Sincronismo
        vlib.SetAlarmMode(i,ALARM_AUTOMATIC_NOTIFY);//Notificacao de alarme automatica
      end;
    end;
    
    for i:=1 to vlib.GetPortsCount do
    begin
      //Seta o formato de gravacao e reproducao
      vlib.SetRecordFormat(i,ffWaveULaw);  
      vlib.SetPlayFormat(i,ffWaveULaw);
    end;
  end;

end;

procedure TForm1.btnFinalizaVlibClick(Sender: TObject);
var
  nRet : Integer;

begin
  //Finaliza a Voicerlib
  nRet := vlib.ShutdownVoicerLib;
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'VoicerLib finalizada com sucesso')
  else
    MostraStatus(0,'Erro ao  finalizada a VoicerLib'); 

end;

procedure TForm1.btnAtender1Click(Sender: TObject);
var
  nRet : Integer;
begin
  //Atende a porta 1
  nRet := vlib.PickUp(StrToInt(txtPorta1.text),100);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta1.text),'Porta atendida com sucesso')
  else
    MostraStatus(StrToInt(txtPorta1.text),'Erro ao atender porta');  
end;

procedure TForm1.btnAtender2Click(Sender: TObject);
var
  nRet : Integer;
begin
  //Atende a porta 2
  nRet := vlib.PickUp(StrToInt(txtPorta2.text),100);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta2.text),'Porta atendida com sucesso')
  else
    MostraStatus(StrToInt(txtPorta2.text),'Erro ao atender porta');  
end;

procedure TForm1.btnComutarClick(Sender: TObject);
var
  nRet : Integer;
begin
  //Estabelece a conexao bi-direcional entre as duas portas
  nRet := vlib.ConnectAudioChannels(StrToInt(txtPorta1.Text), StrToInt(txtPorta2.Text));

  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Comutao realizada com sucesso')
  else
    MostraStatus(0,'Erro ao comutar as portas');

end;

procedure TForm1.vlibRingDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'Ring....'); 
end;

procedure TForm1.btnDesligarClick(Sender: TObject);
var
  nRet : Integer;
begin
  //Efetua a desconexo das duas portas conectadas
  nRet := vlib.DisconnectAudioChannels(StrToInt(txtPorta1.Text), StrToInt(txtPorta2.Text));

  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Comutao encerrada com sucesso')
  else
    MostraStatus(0,'Erro ao encerrar comutao entre as portas');  

  //Desliga as portas
  vlib.HangUp(StrToInt(txtPorta1.Text)); 
  vlib.HangUp(StrToInt(txtPorta2.Text));

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  btnDesligarClick(Sender);
  Timer1.Enabled := False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  //Limpa o Memo
  memStatus.Clear;
end;

procedure TForm1.btnGravarClick(Sender: TObject);
var
  nFormato : Integer;//0-ffWaveULaw, 1-ffSig, 2-ffWavePCM, 3-ffGsm610, 4-ffWaveALaw, 5-ffWave49

begin

  nRet1 := vlib.SetRecordGain(StrToInt(txtPorta1.Text),StrToInt(txtRecordGain.Text)); 
  if nRet1 <> DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta1.Text),'Erro ao setar o ganho de gravao'); 
  nRet2 := vlib.SetRecordGain(StrToInt(txtPorta2.Text),StrToInt(txtRecordGain.Text));
  if nRet2 <> DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta2.Text),'Erro ao setar o ganho de gravao');

  nFormato := vlib.GetRecordFormat(StrToInt(txtPorta1.Text));
  
  //GSM
  if (nFormato = ffGSM610) then
  begin
    //Inicia gravacao
    nRet1:= vlib.RecordFile(StrToInt(txtPorta1.Text),'C:\teste.gsm','');
    if nRet1 <> DG_EXIT_SUCCESS then
      MostraStatus(StrToInt(txtPorta1.Text),'Erro ao iniciar gravao');

    nRet2 := vlib.RecordFile(StrToInt(txtPorta2.Text),'C:\teste1.gsm','');
    if nRet2 <> DG_EXIT_SUCCESS then
      MostraStatus(StrToInt(txtPorta2.Text),'Erro ao iniciar gravao');
  end
  else
  begin   
    //SIG
    if(nFormato = ffSig) then
    begin
      //Inicia gravacao
      nRet1 := vlib.RecordFile(StrToInt(txtPorta1.Text),'C:\teste.sig','');
      if nRet1 <> DG_EXIT_SUCCESS then
        MostraStatus(StrToInt(txtPorta1.Text),'Erro ao iniciar gravao');

      nRet2 := vlib.RecordFile(StrToInt(txtPorta2.Text),'C:\teste1.sig','');
      if nRet2 <> DG_EXIT_SUCCESS then
        MostraStatus(StrToInt(txtPorta2.Text),'Erro ao iniciar gravao');
    end
    else //WAV
    begin
      //Inicia gravacao
      nRet1 := vlib.RecordFile(StrToInt(txtPorta1.Text),'C:\teste.wav','');
      if nRet1 <> DG_EXIT_SUCCESS then
        MostraStatus(StrToInt(txtPorta1.Text),'Erro ao iniciar gravao');

      nRet2 := vlib.RecordFile(StrToInt(txtPorta2.Text),'C:\teste1.wav','');
      if nRet2 <> DG_EXIT_SUCCESS then
        MostraStatus(StrToInt(txtPorta2.Text),'Erro ao iniciar gravao');
    end;
  end;

  MostraStatus(0,'Iniciou gravacao');

end;

procedure TForm1.btnPararGravacaoClick(Sender: TObject);
begin
  //Para gravacao
  nRet1 := vlib.StopRecordFile(StrToInt(txtPorta1.Text));
  if nRet1 <> DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta1.Text),'Erro ao parar gravao');

  nRet2 := vlib.StopRecordFile(StrToInt(txtPorta2.Text));
  if nRet2 <> DG_EXIT_SUCCESS then
    MostraStatus(StrToInt(txtPorta2.Text),'Erro ao parar gravao');

  MostraStatus(0,'Parou gravacao');
end;

procedure TForm1.vlibRecording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
begin
  MostraStatus(Port,'Gravando...');
end;

end.
